import Uploader from './uploader';
export interface Resource {
    javascripts: string[];
    styles: string[];
}
export interface DevopsPublishOptions extends Resource {
    token?: string;
    comment?: string;
    hash: string;
    html?: string;
    server: string;
    projectId: number;
    baseResources?: Resource;
}
export declare const publishDevops: (options: DevopsPublishOptions, uploaders?: Uploader[] | undefined) => Promise<any>;
export interface PublishOptionsV2 extends Resource {
    comment?: string;
    hash: string;
    html?: string;
    server: string;
    projectId: number;
    baseResources?: Resource;
}
/**
 * [publish 外部调用的publish函数，会校验本地的token和弹出输入push note的提示]
 */
export declare const publish: (options: PublishOptionsV2, uploaders?: Uploader[] | undefined) => Promise<any>;
