"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var token_1 = require("./utils/token");
var api_1 = require("./api");
var inquirer = require("inquirer");
var url_1 = require("url");
var logger_1 = require("./utils/logger");
var tokenQuestion = {
    type: 'input',
    name: 'token',
    message: '你还没有初始化token信息，请到eevee的个人信息页面获取token，在这里输入',
};
var pushNoteQuestion = {
    type: 'input',
    message: '请输入资源上传备注',
    name: 'pushNote',
};
var onError = function (error) {
    if (error.response) {
        logger_1.default.log(chalk_1.default.red('Error: →') + error.response.data);
    }
    else {
        logger_1.default.log(error.message);
    }
};
var onData = function (data) {
    if (data.code === 1000) {
        logger_1.default.log(chalk_1.default.green('Success: → ') + JSON.stringify(data));
    }
    else {
        logger_1.default.log(chalk_1.default.red('Error: → ') + JSON.stringify(data));
    }
    return data;
};
var checkServer = function (server) {
    try {
        var u = new url_1.URL(server);
        return u;
    }
    catch (e) {
        logger_1.default.log(chalk_1.default.red("\u5C5E\u6027 server \u2192 " + server + " \u4E0D\u5408\u6CD5"));
        throw new Error(e);
    }
};
var upload = function (uploaders) { return __awaiter(_this, void 0, void 0, function () {
    var _a, _b, _i, i, uploader, err_1;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (!(uploaders && uploaders.length > 0)) return [3 /*break*/, 6];
                _a = [];
                for (_b in uploaders)
                    _a.push(_b);
                _i = 0;
                _c.label = 1;
            case 1:
                if (!(_i < _a.length)) return [3 /*break*/, 6];
                i = _a[_i];
                if (!uploaders[i]) return [3 /*break*/, 5];
                uploader = uploaders[i];
                _c.label = 2;
            case 2:
                _c.trys.push([2, 4, , 5]);
                return [4 /*yield*/, uploader.start()];
            case 3:
                _c.sent();
                return [3 /*break*/, 5];
            case 4:
                err_1 = _c.sent();
                /* tslint:disable-line */ console.log(err_1);
                return [3 /*break*/, 5];
            case 5:
                _i++;
                return [3 /*break*/, 1];
            case 6: return [2 /*return*/];
        }
    });
}); };
/**
 * sendDevopsResourceInfoToServer 调用 publish接口上传devops类型的数据
 * 会在用 push token 来上传资源
 */
function sendDevopsResourceInfoToServer(options) {
    var token = options.token, comment = options.comment, javascripts = options.javascripts, styles = options.styles, hash = options.hash, _a = options.baseResources, baseResources = _a === void 0 ? { javascripts: [], styles: [] } : _a, server = options.server, projectId = options.projectId;
    var params = {
        pushToken: token,
        pushNote: comment,
        javascripts: (baseResources.javascripts || []).concat(javascripts),
        styles: (baseResources.styles || []).concat(styles),
        version: hash,
        projectId: projectId,
    };
    logger_1.default.log(chalk_1.default.green("\uD83D\uDC36  Uploading resources... params: " + JSON.stringify(params)));
    logger_1.default.log(server + "/resources/projects/" + projectId);
    var api = new api_1.default({ server: server });
    return api.publishDevops(params).catch(onError).then(onData);
}
exports.publishDevops = function (options, uploaders) { return __awaiter(_this, void 0, void 0, function () {
    var server;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                server = options.server;
                checkServer(server);
                return [4 /*yield*/, upload(uploaders)];
            case 1:
                _a.sent();
                return [2 /*return*/, sendDevopsResourceInfoToServer(options)];
        }
    });
}); };
/**
 * sendResourceInfoToServer 调用 publish接口上传个人数据
 * 会在用 个人 token 来上传资源
 */
function sendResourceInfoToServer(options, extraInfo) {
    var token = extraInfo.token, pushNote = extraInfo.pushNote;
    var javascripts = options.javascripts, styles = options.styles, hash = options.hash, _a = options.baseResources, baseResources = _a === void 0 ? { javascripts: [], styles: [] } : _a, server = options.server, projectId = options.projectId;
    var params = {
        token: token,
        pushNote: pushNote,
        javascripts: (baseResources.javascripts || []).concat(javascripts),
        styles: (baseResources.styles || []).concat(styles),
        version: hash,
        projectId: projectId,
    };
    logger_1.default.log(chalk_1.default.green("\uD83D\uDC36  Uploading resources... params: " + JSON.stringify(params)));
    logger_1.default.log(server + "/resources/projects/" + projectId);
    var api = new api_1.default({ server: server });
    return api.publish(params).catch(onError).then(onData);
}
/**
 * [publish 外部调用的publish函数，会校验本地的token和弹出输入push note的提示]
 */
exports.publish = function (options, uploaders) { return __awaiter(_this, void 0, void 0, function () {
    var server, u, token, pushNote, result, result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                server = options.server;
                u = checkServer(server);
                return [4 /*yield*/, upload(uploaders)];
            case 1:
                _a.sent();
                token = token_1.readPublishToken(u.host);
                if (!token) return [3 /*break*/, 5];
                pushNote = void 0;
                if (!options.comment) return [3 /*break*/, 2];
                pushNote = options.comment;
                return [3 /*break*/, 4];
            case 2: return [4 /*yield*/, inquirer.prompt([pushNoteQuestion])];
            case 3:
                result = (_a.sent());
                pushNote = result.pushNote;
                _a.label = 4;
            case 4: return [2 /*return*/, sendResourceInfoToServer(options, { token: token, pushNote: pushNote })];
            case 5: return [4 /*yield*/, inquirer.prompt([tokenQuestion, pushNoteQuestion])];
            case 6:
                result = (_a.sent());
                token_1.writePublishToken(result.token, u.host);
                return [2 /*return*/, sendResourceInfoToServer(options, {
                        token: result.token,
                        pushNote: result.pushNote,
                    })];
        }
    });
}); };
