"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var constants_1 = require("./constants");
exports.mkdirIfNotExist = function (dir) {
    if (!fs_1.existsSync(dir)) {
        fs_1.mkdirSync(dir);
    }
};
exports.tokenFileWithSubfix = function (subfix) {
    subfix = subfix || '';
    var file = subfix ? constants_1.tokenPath + "_" + subfix : constants_1.tokenPath;
    /* tslint:disable-line */ console.log("using token use file " + file);
    return file;
};
exports.writePublishToken = function (token, subfix) {
    exports.mkdirIfNotExist(constants_1.mumDir);
    fs_1.writeFileSync(exports.tokenFileWithSubfix(subfix), token, 'utf8');
};
exports.readPublishToken = function (subfix) {
    var token;
    try {
        token = fs_1.readFileSync(exports.tokenFileWithSubfix(subfix), 'utf8');
    }
    catch (e) {
        token = '';
    }
    return token.trim();
};
